/*
*****************************************************************************************************
*****************************************************************************************************
*****                                                                                           *****
*****                  Task Z   -   Task dispatcher                                             *****
*****                                                                                           *****
*****                                                                                           *****
*****                                                                                           *****
*****            Level of Play          Number of Traps                    Number of Styx       *****
*****                                                                                           *****
*****                                                                                           *****
*****                  1                  1                                       1             *****
*****                  2                  2                                       1             *****
*****                  3                  2                                       2             *****
*****                  4 & above          2 Lengthening                           2             *****
*****                                                                                           *****
*****                                                                                           *****
*****                                                                                           *****
*****************************************************************************************************
*****************************************************************************************************
*/

#include	"styx.h"

int	dead, lives, level, full, dummy;

main()
{
	int	loop, temp, y, copyok;

	dummy=175;	/* rounds off checksum during creation */

	copyok=0;	/* flag to indicate copy protection */

	mesage();	/* display message to turn on the color display */

	if(!medres(0))	/* if no color card is present then the program loops for ever */
		endloop();

        copyok=prochk();	/* set up copy protect flag */
	if(!copyok)
		nfg_crash();	/* exit if it is an illegal copy */
	
	kb_init(); keychr=0;	/* initialize the keyboard */ 

	init_hi_score(); init_sound();	/* initialize high score & sound */


	while(TRUE) {	/* continuous loop for game */

		if(!keychr || (keychr&0x80)) {	/* go directly to game if a key was pressed */
			medres(0);	/* clear the screen to med-res */ 
			outp(0x3d9,0);	/* switch to low intensity */	
			gentitle();	/* display title page in med-res */  
                	show_scores(); 	/* show high scores on title page */ 
		}
		init_joy();	/* initialize the joystick */
		start_wait();	/* wait for a key to be pressed or the joystick button */
				/* if the joystick is used - the stick MUST be centred when the button is pressed */
		keychr=0;	/* reset to prevent a pause when started with a space */
		screen=FALSE;	/* draw the new screen without being displayed */
		lowres(6);
		clear(0); 	/* clears the memory buffer alse */
		line(0+1,8+1,159-1,8+1,DARK_WHITE);
		line(159-1,8+1,159-1,99-1,DARK_WHITE);
		line(159-1,99-1,0+1,99-1,DARK_WHITE);
		line(0+1,99-1,0+1,8+1,DARK_WHITE);

		line(0+2,8+2,159-2,8+2,DARK_WHITE);
		line(159-2,8+2,159-2,99-2,DARK_WHITE);
		line(159-2,99-2,0+2,99-2,DARK_WHITE);
		line(0+2,99-2,0+2,8+2,DARK_WHITE);

		level=1; lives=3; 
		rst_score(); init_th(); /* reset score & sound */
		keychr=0;
		init_level();
		screen=TRUE;
		retscn();	/* get screen from the memory buffer */

		while(lives) {	/* loop while the player has lives left */

			dead=FALSE;	/* reset player dead status flag */
			while(!dead && !full) {

				if(!copyok)	/* continuous check for copy protect */
					nfg_crash();
				task_c();	/* move man */
				task_a();	/*    move styx */
				task_h();			/* update sound */
				task_b();	/* move traps */

				task_c();	/* move man */
				task_a();	/*    move styx */
				task_h();			/* update sound */
				task_b();	/* move traps */
				task_c();	/* move man */
				task_b();	/* move traps */

				task_c();	/* move man */
				task_a();	/*    move styx */
				task_h();			/* update sound */
				task_c();	/* move man */
				task_b();	/* move traps */

				task_f();	/* update scoring */
				exit_check();	/* check for a space key to pause game */
			}

			if(dead) {	/* man is dead */
				kill_man();	/* remove man */
				stop_traps();	/* remove traps */
				start_all_traps();	/* prepare traps for next time */
/* 				if(!fire)	/* used during debug as a no die option */   */
				lives--;
				print_present_score();	/* update score */
			}

			if(full) {	/* screen is full */
				sn2_off();	/* stop any sound */
				stop_traps();	/* remove traps */
				draw_man();	/* remove man from present position */
				check_bonus();	/* display bonus as it is awarded */
				empty_screen();	/* clear memory screen buffer & make sounds */
				level++;	/* advance level of play */
				if(level>9)
					level=9;

#ifdef	DEBUG
				cprintf("starting level %d \n\r",level);
#endif
				screen=FALSE;	/* blank out the top of the screen */
				for(y=0; y<9; y++) 
					line(0,y,159,y,BLACK);
				screen=TRUE;
				init_level();
				retscn();	/* return with the screen ready to start the next level */
			}
		}

		check_hi_score();	/* check if a high score has been reached */

	}

}



init_level()	/* initialize variables for the present level of play */
{
	int	y;

	full=FALSE;
	init_ta();	/* set initial values of styx */
	init_tb();	/* clear all trap info tables */
	init_tc();	/* create man */
	init_tf();	/* reset scoring sequences */
	print_present_score();
}





empty_screen()	/* clear memory buffer & make full or high score sound */
{
	int	temp, y;

	init_sfull();
	screen=FALSE;	/* don't display untill done */

	for(y=11; y<28; y++)
		line(3,y,156,y,BLACK);
	temp=28;
	while(temp<97) {
		for(y=temp; y<temp+3; y++)
			line(3,y,156,y,BLACK);
		snd_sfull();
		temp+=3;
	}
	snd_slide();
	init_sfull();	/* turn off sound for the rest of the time */
	screen=TRUE;

}



make_dead(status)
int	status;
{
	dead=status;

}


make_full(val)
int	val;
{
	full=val;

}


get_status()
{
	if(dead || full)
		return(TRUE);
	else
		return(FALSE);

}


get_level()
{
	return(level);
}



make_level(x)
{
	level=x;

}


get_lives()
{
	return(lives);

}


exit_check()
{	/* check for a hold condition - also exit to dos during debug */

/*
	if(endgame) {	/*	removed for sale vertion  */
		rst_sound();
		kb_rst();  
		sn2_stop(); 
		_exit();
	}
*/

	if(keychr==57 || keychr==185) {	/* check for a hold condition */
		set_sound(40);	/* turn off sound */ 
		sn2_off();
		text_color(DARK_CYAN);	/* change text color */
		write_text("  PRESS ANY KEY ",0,1);	/* display message at top of screen */
		while(keychr==57)	/* hold game while pressing space key */
			set_sound(40);
		while(keychr & 0x80)	/* hold game while last character was a key up */
			set_sound(40);
		text_color(DARK_WHITE);	/* reset text color */
		write_text("                ",0,1);	/* blank area where message was displayed */
		print_present_score();	/* reprint top status line */
		keychr=0;	/* reset key incase game was restarted with a space key */
	}
}


endloop()
{
	int	temp;

	while(TRUE)
		temp=temp;	/* continuous loop trap */
}


nfg_crash()
{
	int	temp;

	medres(1);	/* restore med res mode */
	col_print("This program is copy protected",3);	/* print in white */
	endloop();
}
