/*
*****************************************************************************************************
*****************************************************************************************************
*****                                                                                           *****
*****                  Task B   -   Trap movement                                               *****
*****                                                                                           *****
*****************************************************************************************************
*****************************************************************************************************
*/

#include	"styx.h"
#define		TRAP_MAX	2
#define		DOT_MAX		60

extern	int	m_x_pos, m_y_pos;
extern	int	x_start[], y_start[];

int	t_x_pos[TRAP_MAX], t_y_pos[TRAP_MAX], t_direction[TRAP_MAX], t_step_dir[TRAP_MAX], trap_length[TRAP_MAX];
int	trap_dot[DOT_MAX*TRAP_MAX][3];	/* trap_dot[x][0]=X coordinate, trap_dot[x][1]=Y coordinate, trap_dot[x][2]=color */
int	on_dot[TRAP_MAX], off_dot[TRAP_MAX], dot_type[TRAP_MAX], t_new[TRAP_MAX], t_stuck[TRAP_MAX];
int	t_x_temp, t_y_temp, t_colision;
int	traps_active;



init_tb()
{
	if(get_level()<2)
		traps_active=1;
	else
		traps_active=2;
	start_all_traps();
}



task_b()
{
	int	loop, loopend, trap_num;


	if(get_level()>2 && get_styx()==1)
		loopend=2;
	else
		loopend=1;

	for(loop=0; loop<loopend; loop++) {

		if(get_status() )	/* abort routine if man is dead already */
			return(FALSE);


	        t_colision=0;	/* reset colision flag */

		/* move active traps */
		for(trap_num=0; trap_num<traps_active; trap_num++) {
			if(t_new[trap_num]) {	/* create a new trap */
				start_trap(trap_num);
				sleep(2);
			}
			else {	/* move trap existing trap */
				move_trap(trap_num);
			}
			if(get_status())
				return(FALSE);	/* exit if a trap has killed the man */

		}
		if(traps_active==1) /* if only one trap then delay */
			sleep(2);

		check_traps();	/* check for traps that are stuck in a filled area */

	}

}



move_trap(trap_num)
int	trap_num;
{
	int	count;

	t_x_temp=t_x_pos[trap_num]; t_y_temp=t_y_pos[trap_num];	/* establish temperary values */

	if(t_direction[trap_num]==LEFT) {	/* traps may move in boath directions around the perimiter */
		/* start searching for an open spot at lowest posible angle */
		dec_step_direction(trap_num);	/* decrement direction with wrap-ariund */
		dec_step_direction(trap_num);
		dec_step_direction(trap_num);
	}
	else {
		inc_step_direction(trap_num);	/* increment direction with wrap-ariund */
		inc_step_direction(trap_num);
		inc_step_direction(trap_num);
	}
	for(count=9; count>0; count--) {	/* find blank dot first, exit with same angle if no open dot is found */
		t_x_temp=t_x_pos[trap_num]; t_y_temp=t_y_pos[trap_num];	/* get new X & Y coordinates */
		move_temp(t_step_dir[trap_num]);	/* get new temp X & Y points */
		if(xpset(t_x_temp,t_y_temp,BLACK) & 0x1001) {	/* exit when a blank or light red dot is found */
			t_stuck[trap_num]=0;	/* reset stuck count if a good move is made */
			break;
		}

		if(count==1) {	/* check if an open spot is not found */
			t_stuck[trap_num]++;
			break;	/* leave pointing in the origional direction */
		}
		if(t_direction[trap_num]==LEFT) 	/* traps may move in boath directions around the perimiter */
			inc_step_direction(trap_num);	/* increment direction with wrap-ariund */
		else
			dec_step_direction(trap_num);	/* decrement direction with wrap-ariund */
	}
	for(count=8; count>0; count--) {	/* find a dark white, grey or light cyan dot */
		t_x_temp=t_x_pos[trap_num]; t_y_temp=t_y_pos[trap_num];	/* get new X & Y coordinates */
		move_temp(t_step_dir[trap_num]);	/* get new temp X & Y points */
		if(xpset(t_x_temp,t_y_temp,BLACK) & 0x0980)
			break;	/* exit when a dark white, grey or light cyan dot is found */
		if(t_direction[trap_num]==LEFT)	/* traps may move in boath directions around the perimiter */
			inc_step_direction(trap_num);	/* increment direction with wrap-ariund */
		else
			dec_step_direction(trap_num);	/* decrement direction with wrap-ariund */
		t_x_temp=t_x_pos[trap_num]; t_y_temp=t_y_pos[trap_num];	/* reset position in case error */
	}

	t_x_pos[trap_num]=t_x_temp; t_y_pos[trap_num]=t_y_temp;	/* make variables perminent */

        /* allow line to become longer */
	if((random(get_level())>3 && random(12-get_level())==1 && trap_length[trap_num]<DOT_MAX-2) || trap_length[trap_num]<8) {
		trap_length[trap_num]++;
	}
	else
		t_colision |= turn_off_dot(trap_num);	/* erase last dot of line */

	t_colision |= turn_on_dot(trap_num);	/* draw new dot */

	/* kill man if any trap hit man */
	if( (t_colision & 0xfe7f) || ((abs(t_x_pos[trap_num]-m_x_pos)<3) && (abs(t_y_pos[trap_num]-m_y_pos)<3)) ) {
		make_dead(SNAKE);
	}


}



start_all_traps()	/* initialize all active traps */
{
	int	trap_num;

	for(trap_num=0; trap_num<traps_active; trap_num++) 
		create_trap(trap_num);

}


create_trap(trap_num)	/* initialize a trap */
int	trap_num;
{

	t_new[trap_num]=TRUE; t_stuck[trap_num]=0;
	t_x_pos[trap_num]=x_start[0]; t_y_pos[trap_num]=y_start[0];

	if(trap_num==0) {
		while( !(xpset(t_x_pos[0],t_y_pos[0],BLACK) & 0x0080) )	/* find first vacent position */
			t_x_pos[0]--;
		t_step_dir[0]=2; t_direction[0]=LEFT;
	}
	else {
		while( !(xpset(t_x_pos[1],t_y_pos[1],BLACK) & 0x0080) )	/* find first vacent position */
			t_x_pos[1]++;
		t_step_dir[1]=6; t_direction[1]=RIGHT;
	}

}



start_trap(trap_num)	/* start a trap on the screen */
int	trap_num;
{

	if( ((abs(t_x_pos[trap_num]-m_x_pos)>20) || (abs(t_y_pos[trap_num]-m_y_pos)>20)) ) {
		trap_length[trap_num]=1;			/* set line lingth to 1 unit */
		on_dot[trap_num]=0; off_dot[trap_num]=0;		/* set up pointers to line start & end points */
		dot_type[trap_num]=TRUE;			/* set dot color to on */
		trap_dot[on_dot[trap_num]+trap_num*DOT_MAX][0]=t_x_pos[trap_num];	/* save X position */
		trap_dot[on_dot[trap_num]+trap_num*DOT_MAX][1]=t_y_pos[trap_num];	/* save Y position */
		trap_dot[on_dot[trap_num]+trap_num*DOT_MAX][2]=BLACK;	/* save color */
		on_dot[trap_num]++;	/* create a fake dot so somthing can be turned off */
		t_new[trap_num]=FALSE;
	}
}


stop_traps()
{	/* erase all trap elements on screen */
	int	trap_num;

	for(trap_num=0; trap_num<traps_active; trap_num++) 
		rem_trap(trap_num);

}


rem_trap(trap_num)	/* erase trap from screen */
int	trap_num;
{

	while(on_dot[trap_num]!=off_dot[trap_num])	/* turn off any trap element still on */
		turn_off_dot(trap_num);

}


check_traps()	/* check that a trap is not stuck in a filled area */
{
	int	trap_num;

	for(trap_num=0; trap_num<traps_active; trap_num++) {
		if(t_stuck[trap_num]>100) {	/* a trap is considered stuck after 100 moves in a filled area */
			rem_trap(trap_num);	/* erase trap */
			create_trap(trap_num);	/* create a new trap */
		}
	}

}			

turn_on_dot(trap_num)	/* draw a new dot on screen, as the line is dark white - grey will result when light white used */
int	trap_num;
{
	int	colision, color;

	if(dot_type[trap_num])	/* get trap element color */
		color=LIGHT_WHITE;
	else
		color=BLACK;

	trap_dot[on_dot[trap_num]+trap_num*DOT_MAX][0]=t_x_pos[trap_num];	/* save X position */
	trap_dot[on_dot[trap_num]+trap_num*DOT_MAX][1]=t_y_pos[trap_num];	/* save Y position */
	trap_dot[on_dot[trap_num]+trap_num*DOT_MAX][2]=color;	/* save color */
	colision=xpset(t_x_pos[trap_num],t_y_pos[trap_num],color);	/* draw dot on screen */
	on_dot[trap_num]++;	/* increment pointer with wrap-around */
	if(on_dot[trap_num]>=DOT_MAX)
		on_dot[trap_num]=0;
	if(dot_type[trap_num])	/* toggle color of dot */
		dot_type[trap_num]=FALSE;
	else
		dot_type[trap_num]=TRUE;

	return(colision);	/* return colision color value */
}


turn_off_dot(trap_num)	/* erase dot from screen */
int	trap_num;
{
	int	colision;

	colision=xpset(trap_dot[off_dot[trap_num]+trap_num*DOT_MAX][0],
	      trap_dot[off_dot[trap_num]+trap_num*DOT_MAX][1],
	      trap_dot[off_dot[trap_num]+trap_num*DOT_MAX][2]);
	off_dot[trap_num]++;	/* increment pointer with wrap-around */
	if(off_dot[trap_num]>=DOT_MAX)
		off_dot[trap_num]=0;

	return(colision);

}



move_temp(direct)	/* get new values for temp variables acording to direction of travel */
int	direct;
{
	switch(direct) {
	case 0:	/* direction is to the right */
		t_x_temp++;
		break;
	case 1:	/* direction is up and to the right */
		t_x_temp++; t_y_temp--; 
		break;
	case 2:	/* direction is up */
		t_y_temp--;
		break;
	case 3:	/* direction is up and to the left */
		t_x_temp--; t_y_temp--; 
		break;
	case 4:	/* direction is to the left */
		t_x_temp--;
		break;
	case 5:	/* direction is down and to the left */
		t_x_temp--; t_y_temp++; 
		break;
	case 6:	/* direction is down */
		t_y_temp++;
		break;
	case 7:	/* direction is down and to the right */
		t_x_temp++; t_y_temp++; 
		break;
	default:
#ifdef DEBUG
		cprintf("error in movement\n\r");
#endif
		break;
	}	
}



dec_step_direction(trap_num)	/* decrement the step direction value with wrap-around */
{
	t_step_dir[trap_num]--;
	if(t_step_dir[trap_num]<0)
		t_step_dir[trap_num]=7;
}


inc_step_direction(trap_num)	/* increment the step direction value with wrap-around */
{
	t_step_dir[trap_num]++;
	if(t_step_dir[trap_num]>7)
		t_step_dir[trap_num]=0;
}
