
/*
*****************************************************************************************************
*****************************************************************************************************
*****                                                                                           *****
*****                  Task C   -   man movement                                               *****
*****                                                                                           *****
*****************************************************************************************************
*****************************************************************************************************
*/

#include	"styx.h"

#define		NEW		0
#define		EDGE		1

#define		READY		0
#define		KEY_DELAY	4

#define		NEW_DOT_MAX	2000
#define		X_POS		0
#define		Y_POS		1

extern 	int 	x_start[], y_start[];
extern 	int 	bcount;

int	m_x_pos, m_y_pos, m_x_old, m_y_old, m_direction, new_man, m_travel, dir_lock,last_dir;

int	m_x_temp, m_y_temp, m_dir_temp, m_x_last, m_y_last, m_dir_last, m_movement;
int	m_stuck, man_dot_count, x_fill, y_fill, fill_color, bad_fill;

int	new_dot[2][NEW_DOT_MAX];

char	man_image[]= {	5,5,
			0x88,0x0c,0x0c,0x0c,0x88,
			0x0c,0x0c,0x0c,0x0c,0x0c,
			0x0c,0x0c,0x0c,0x0c,0x0c,
			0x0c,0x0c,0x0c,0x0c,0x0c,
			0x88,0x0c,0x0c,0x0c,0x88 };


char	man_c_image[]= {	5,5,
				0x88,0x00,0x00,0x00,0x88,
				0x00,0x00,0x00,0x00,0x00,
				0x00,0x00,0x00,0x00,0x00,
				0x00,0x00,0x00,0x00,0x00,
				0x88,0x00,0x00,0x00,0x88 };


init_tc()
{
	int	loop;

	m_x_last=80; m_y_last=97;	/* set up X & Y position of man */

	m_dir_last=2;	/* initialize direction of travel */ 
	m_movement=RIGHT;
	tc_start();	/* set up start conditions for man */

}


task_c()
{
	int	colision, temp;

	if(get_status() )	/* abort routine if man is already dead */
		return(FALSE);

	joystk();	/* update joystick and buttons for game variables */

	if(m_travel==EDGE && !new_man) {	/* allow man to begin drawing or to change direction */
		temp=check_turn();
		if(temp<99) {
			m_dir_temp=m_direction;	/* check for reverse direction */
			inc_m_step_direction();
			inc_m_step_direction();
			inc_m_step_direction();
			inc_m_step_direction();
			if(m_dir_temp==temp)
				change_direction();

			if(get_button() ) {	/* check if new drawing is required */

				if(m_movement==RIGHT) {	/* find first fill location */
					/* establish temp variables */
					m_x_temp=m_x_pos; m_y_temp=m_y_pos; m_dir_temp=m_direction;
					inc_m_step_direction();	/* change direction to the left */
					move_m_temp(m_dir_temp);	/* make first move */
					dec_m_step_direction();		/* turn one step right to point to the 
									   first fill location */ 
					move_m_temp(m_dir_temp);	/* set temparary variables to first fill dot */
					x_fill=m_x_temp; y_fill=m_y_temp; 
				}
				else {
					/* establish temp variables */
					m_x_temp=m_x_pos; m_y_temp=m_y_pos; m_dir_temp=m_direction;
					dec_m_step_direction();	/* change direction to the left */
					move_m_temp(m_dir_temp);	/* make first move */
					inc_m_step_direction();		/* turn right to point to the first fill location */ 
					move_m_temp(m_dir_temp);	/* set temparary variables to first fill dot */
					x_fill=m_x_temp; y_fill=m_y_temp; 
				}

				/* a test move is made to check if drawing may begin 
				   - if the first location is vacent then OK to start */
				m_x_temp=m_x_pos; m_y_temp=m_y_pos; m_dir_temp=temp;	/* establish temparary variables */
				move_m_temp(m_dir_temp);	/* make first move */

				colision=xpset(m_x_temp,m_y_temp,BLACK);	/* check contents of first fill dot */
				if((colision & 0x1001) ) { 	/* first spot to fill is empty & button is pressed */
					/* set perminent variables */
					m_x_last=m_x_pos; m_y_last=m_y_pos; m_dir_last=m_direction;
					m_travel=NEW;	/* travel is on free screen area */
					m_direction=m_dir_temp;	/* change perminent direction */
					dir_lock=FALSE;	/* allow direction change from keyboard */
					man_dot_count=0;	/* reset dot position pointer */
					last_dir=m_direction;	/* last direction of travel for direction validity check */
				}
			}
		}
	}


	if(m_travel==EDGE) {	/* proform movement of man */
		edge_move();	/* move around perimiter of free area */
	}
	else {
		new_move();	/* move in free area of screen */
	}
}



tc_start()
{	
	joystk();	/* reset keyboard flag */
	new_man=TRUE;	/* when new_man=true, the old location should not be erased */
	dir_lock=FALSE;	/* alow change of direction */
	m_travel=EDGE;	/* start travel around perimiter */
	/* set man at last good screen location on perimeter */	
	m_x_pos=m_x_last; m_y_pos=m_y_last; m_direction=m_dir_last;
	m_stuck=0;
	fires=FALSE;
	bad_fill=FALSE;
}



edge_move()
{	/* move man around edge of free screen area */
	int	count, colision;

	init_stuck();	/* reset sound to indicate man stuck */
	m_stuck=0;	/* reset counter to indicate man stuck */

	/* move man */
	m_x_temp=m_x_pos; m_y_temp=m_y_pos; m_dir_temp=m_direction;	/* establish temperary values */
	m_x_old=m_x_pos; m_y_old=m_y_pos;	/* store old locations */

	if(m_movement==RIGHT) {
		inc_m_step_direction();	/* increment direction with wrap-ariund */
		inc_m_step_direction();
		inc_m_step_direction();
	}
	else {
		dec_m_step_direction();	/* increment direction with wrap-ariund */
		dec_m_step_direction();
		dec_m_step_direction();
	}

	for(count=8; count>0; count--) {	/* find blank dot first */
		/* get new X & Y coordinates */
		m_x_temp=m_x_pos; m_y_temp=m_y_pos;
		move_m_temp(m_dir_temp);

		colision=xpset(m_x_temp,m_y_temp,BLACK);
		if(colision & 0x1001)
			break;	/* exit when a blank or light red dot is found */

		if(m_movement==RIGHT) 
			dec_m_step_direction();	/* decrement direction with wrap-ariund */
		else
			inc_m_step_direction();	/* decrement direction with wrap-ariund */
	}
	for(count=8; count>0; count--) {	/* find a dark white or light cyan dot */
		/* get new X & Y coordinates */
		m_x_temp=m_x_pos; m_y_temp=m_y_pos;
		move_m_temp(m_dir_temp);
		colision=xpset(m_x_temp,m_y_temp,BLACK);
		if(colision & 0x0880)
			break;	/* exit when a dark white or light cyan dot is found */

		if(m_movement==RIGHT) 
			dec_m_step_direction();	/* decrement direction with wrap-ariund */
		else
			inc_m_step_direction();	/* decrement direction with wrap-ariund */
		m_x_temp=m_x_pos; m_y_temp=m_y_pos;	/* reset position in case of error */
	}
        
	if(new_man) 
		create_man();	/* draw lines comoing to create the man */
	else { 	/* positions are not moved if it is a new man - may be on top of somthing */
		m_x_pos=m_x_temp; m_y_pos=m_y_temp;m_direction=m_dir_temp;	/* make variables perminent */
		erase_man();	/* remove old man - if new_man then no old man would be on screen */
	}



	colision=draw_man();	/* draw new man */

	if(colision & 0x0668) {	/* check if man hit the styx */
		put_man();	/* change ant dots overlayed by the styx to regulas color */
	}			

	if(colision & 0x0100) {	/* check if man hit a trap */
		make_dead(MAN);
	}
	else {
		/* set last good location values for future re-initialization */
		m_x_last=m_x_pos; m_y_last=m_y_pos; m_dir_last=m_direction;
	}

	if(new_man)	/* reset flag to show that that first move has occured */
		new_man=FALSE;

}


new_move()
{	/* move man on free area of screen */
	int	colision, x_new, y_new, dir_new, count;

	m_x_temp=m_x_pos; m_y_temp=m_y_pos; m_dir_temp=m_direction;	/* establish temparary variables */
	m_x_old=m_x_pos; m_y_old=m_y_pos;	/* save old location */


/* ++++++++++++++++++  allow change of direction  +++++++++++++++++++*/


	/* allow change of direction if not locked toward an edge */
	if(get_button())
		dir_new=check_turn();
	else
		dir_new=99;

	/* check if man is traveling oposite on his last direction */

	if(dir_new<99) {	/* only check if the new direction is valid */
		m_dir_temp=dir_new;
		inc_m_step_direction();	/* point in oposite direction */
		inc_m_step_direction();
		inc_m_step_direction();
		inc_m_step_direction();
		if(m_dir_temp==last_dir) 
			dir_new=99;	/* don't allow this direction */
	}


	/* check if man is traveling one direction step away from last direction */

	if(dir_new<99) {	/* only check if the new direction is valid */
		m_dir_temp=dir_new;
		inc_m_step_direction();	/* point in oposite direction */
		inc_m_step_direction();
		inc_m_step_direction();
		if(m_dir_temp==last_dir) {
			dec_m_step_direction();	/* change direction to avoid colision with trail */
			dir_new=m_dir_temp;
		}
		m_dir_temp=dir_new;
		dec_m_step_direction();	/* point in oposite direction */
		dec_m_step_direction();
		dec_m_step_direction();
		if(m_dir_temp==last_dir) {
			inc_m_step_direction();	/* change direction to avoid colision with trail */
			dir_new=m_dir_temp;
		}
	}

	m_dir_temp=m_direction;	/* setup temporary variables */

       	if((!dir_lock) && dir_new<99) 
		m_dir_temp=dir_new;


/* ++++++++++++++++++++  move man & check if an edge can be reached +++++++++++++++++++  */

	if(dir_new==99 && !dir_lock)
		inc_stuck();	/* stuck count is increased when man is not moving */
	else {
		/* move in the normal direction of travel */
		move_m_temp(m_dir_temp);	/* move temparary position */
		x_new=m_x_temp; y_new=m_y_temp; 	/* save new position */
		if(xpset(m_x_temp,m_y_temp,BLACK) & 0x0880) {	/* if line lits an edge then set up edge travel for next move */
			m_travel=EDGE;	/* set up edge travel */
			dir_lock=FALSE;	/* allow change of direction for next move */
		}
	
		m_x_pos=x_new; m_y_pos=y_new; m_direction=m_dir_temp;	/* make variables perminent */
	}


/*  +++++++++++++++++  check if a wall is near - set direction toward wall if one is near  ++++++++++++++++  */

	dir_new=m_direction;

	m_dir_temp=m_direction;	/* establish temperary values */

	/* check present direction, one direction left & one direction right */
	dec_m_step_direction();	/* decrement direction with wrap-ariund */
	for(count=0; count<3; count++) {	/* find a dark white or light cyan dot */
		/* get new X & Y coordinates */
		m_x_temp=m_x_pos; m_y_temp=m_y_pos;	/* reset temparary positions */
		move_m_temp(m_dir_temp);	/* move temparary positions */
		colision=xpset(m_x_temp,m_y_temp,BLACK);
		move_m_temp(m_dir_temp);	/* move temparary positions */
		colision |= xpset(m_x_temp,m_y_temp,BLACK);

		if(colision & 0x0880) {	/* check for a dark white or light cyan dot */
			dir_new=m_dir_temp;	/* set permenent direction */
			dir_lock=TRUE;	/* lock direction so keyboard will not change it */
		}
		inc_m_step_direction();	/* increment direction with wrap-ariund to try next direction */
	}


	m_dir_temp=m_direction;	/* establish temperary values */

	/* check present direction again to give it priority */
	m_x_temp=m_x_pos; m_y_temp=m_y_pos;	/* reset temparary positions */
	move_m_temp(m_dir_temp);	/* move temparary positions */
	colision=xpset(m_x_temp,m_y_temp,BLACK);
	move_m_temp(m_dir_temp);	/* move temparary positions */
	colision |= xpset(m_x_temp,m_y_temp,BLACK);

	if(colision & 0x0880) {	/* check for a dark white or light cyan dot */
		dir_new=m_dir_temp;	/* set permenent direction */
		dir_lock=TRUE;	/* lock direction so keyboard will not change it */
	}


	m_dir_temp=m_direction;	/* establish temperary values */

	/* check present direction, one direction left & one direction right */
	dec_m_step_direction();	/* decrement direction with wrap-ariund */
	for(count=0; count<3; count++) {	/* find a dark white or light cyan dot */
		/* get new X & Y coordinates */
		m_x_temp=m_x_pos; m_y_temp=m_y_pos;	/* reset temparary positions */
		move_m_temp(m_dir_temp);	/* move temparary positions */
		colision=xpset(m_x_temp,m_y_temp,BLACK);

		if(colision & 0x0880) {	/* check for a dark white or light cyan dot */
			dir_new=m_dir_temp;	/* set permenent direction */
			dir_lock=TRUE;	/* lock direction so keyboard will not change it */
		}
		inc_m_step_direction();	/* increment direction with wrap-ariund to try next direction */
	}


	m_dir_temp=m_direction;	/* establish temperary values */

	/* check present direction again to give it priority */
	m_x_temp=m_x_pos; m_y_temp=m_y_pos;	/* reset temparary positions */
	move_m_temp(m_dir_temp);	/* move temparary positions */
	colision=xpset(m_x_temp,m_y_temp,BLACK);

	if(colision & 0x0880) {	/* check for a dark white or light cyan dot */
		dir_new=m_dir_temp;	/* set permenent direction */
		dir_lock=TRUE;	/* lock direction so keyboard will not change it */
	}

	m_direction=dir_new;	/* store best direction for next time */

/*  +++++++++++++++++++++++++ check if man hits own trail   +++++++++++++++++++++ */

	if((check_man() & 0x8000) && !dir_lock) {
		m_x_pos=m_x_old; m_y_pos=m_y_old;
		inc_stuck();	/* man is stuck if he tries to cross his own trail */
	}

				

/*  +++++++++++++++++++++++++  update screen after movement  ++++++++++++++++++++  */

	erase_man();

	if(m_travel==NEW) {	/* man is still in free area */
		last_dir=m_direction;	/* save last direction for validity check next time */
		if(xpset(m_x_pos,m_y_pos,BLACK) & 0x0001) {	/* set dot if not already present */
			xpset(m_x_pos,m_y_pos,LIGHT_WHITE);
			new_dot[X_POS][man_dot_count]=m_x_pos;	/* save dot positions for later change to dark white */
			new_dot[Y_POS][man_dot_count]=m_y_pos;
			man_dot_count++;	/* increment pointer */
			if(man_dot_count>=NEW_DOT_MAX)
				make_dead(MAN);
			if(m_stuck)	/* slowly decrease stuck count for good moves */
				m_stuck--;
			init_stuck();	/* reset sound for stuck */
		}
	}
       	else {	/* man reached edge - change line color & fill area */
		if(man_dot_count>1) {	/* line must be longer than one dot */
			m_x_pos=m_x_old; m_y_pos=m_y_old;
			fires=FALSE;
			m_stuck=0;	/* reset stuck counter */
			claim_screen();	/* fill area & award points ext */
			if(!(xpset(x_fill,y_fill,BLACK) & 0x0096))	/* change direction of travel */ 
				change_direction();
			bad_fill=FALSE;	/* indicate a sucessfull fill */
		}
		else {
			erase_screen();	/* remove any trail on screen */
			if(bad_fill) {	/* stop trap from getting stuck in a tight corner */
				change_direction();
				bad_fill=FALSE;
			}
			else
				bad_fill=TRUE;	/* set flag to create a direction change if the next fill is bad */
		}
	}

	if(m_stuck>100)	/* man is not allowed to be stuck for more than 100 counts */
		make_dead(MAN);			

/*	if(m_stuck)
		cprintf("stuck= %d ",m_stuck);
*/

	colision=draw_man();
	if(colision & 0x0768) {	/* check if man hit somthing */
		make_dead(MAN);
	}

}


inc_stuck()	/* increase the stuck counter */
{

	m_stuck+=5;
	snd_stuck(m_stuck);

}



change_direction()	/* change man direction of edge travel */
{
	if(m_movement==RIGHT)
		m_movement=LEFT;
	else
		m_movement=RIGHT;
}



check_man()	/* check if man is on top of anything */
{
	return(xput(m_x_pos-2,m_y_pos-2,man_c_image));	/* check points used by man on screen */
}



draw_man()
{
	return(xput(m_x_pos-2,m_y_pos-2,man_image));	/* draw man on screen */
}



erase_man()
{
	xput(m_x_old-2,m_y_old-2,man_image);	/* erase old man from screen */

}


put_man()
{	/* restore colors of man after putting over a styx */

	register	x, y, loop;

	man_hide();	/* remove man from screen */
	loop=2;
	for(y=m_y_pos-2; y<m_y_pos+3; y++) {
		for(x=m_x_pos-2;x<m_x_pos+3; x++) {
			if((xpset(x,y,BLACK) & 0x0668) && man_image[loop]==0x0c) 
				pset(x,y,BLACK);
			loop++;
		}
	}
	man_display();	/* replace man on screen */
}


kill_man()	/* erase man from screen with a big bang */
{
	int	s_loop, r_loop, line_s_length, line_s_total, line_r_length, line_r_total;
	int	set_x_1, set_y_1, set_x_2, set_y_2, set_x_3, set_y_3, set_x_4, set_y_4;
	int	rst_x_1, rst_y_1, rst_x_2, rst_y_2, rst_x_3, rst_y_3, rst_x_4, rst_y_4;

	init_sdead();	/* sound for dead */
	if(!new_man) {	/* only restart if a man is on screen */

		draw_man();	/* erase present man position */	

		/* draw lines immitting from mans old position */

		line_s_total=2;
		line_s_length=line_s_total/2;
		line_r_total=2;
		line_r_length=line_r_total/2;

		set_x_1=m_x_pos; set_x_2=m_x_pos; set_x_3=m_x_pos; set_x_4=m_x_pos; 
		set_y_1=m_y_pos; set_y_2=m_y_pos; set_y_3=m_y_pos; set_y_4=m_y_pos; 
		rst_x_1=m_x_pos; rst_x_2=m_x_pos; rst_x_3=m_x_pos; rst_x_4=m_x_pos; 
		rst_y_1=m_y_pos; rst_y_2=m_y_pos; rst_y_3=m_y_pos; rst_y_4=m_y_pos; 


		r_loop=0; s_loop=0;
		while(r_loop<45) {

			if(s_loop<45) {
				set_x_1+=2; set_y_1+=2;	/* direction 7 */
				set_x_2+=2; set_y_2-=2;	/* direction 1 */
				set_x_3-=2; set_y_3-=2;	/* direction 3 */
				set_x_4-=2; set_y_4+=2;	/* direction 5 */
				line_s_length=line_s_total/2;
        
				xline(set_x_1+line_s_length,set_y_1-line_s_length,
				      set_x_1-line_s_length,set_y_1+line_s_length,LIGHT_RED);
				snd_sdead();
				xline(set_x_2-line_s_length,set_y_2-line_s_length,
				      set_x_2+line_s_length,set_y_2+line_s_length,LIGHT_RED);
				snd_sdead();
				xline(set_x_3+line_s_length,set_y_3-line_s_length,
				      set_x_3-line_s_length,set_y_3+line_s_length,LIGHT_RED);
				snd_sdead();
				xline(set_x_4-line_s_length,set_y_4-line_s_length,
				      set_x_4+line_s_length,set_y_4+line_s_length,LIGHT_RED);
				snd_sdead();

				if(line_s_total<30)
					line_s_total++;
				s_loop++;

			}


                        if(s_loop>16) {
				rst_x_1+=2; rst_y_1+=2;	/* direction 7 */
				rst_x_2+=2; rst_y_2-=2;	/* direction 1 */
				rst_x_3-=2; rst_y_3-=2;	/* direction 3 */
				rst_x_4-=2; rst_y_4+=2;	/* direction 5 */
				line_r_length=line_r_total/2;

				xline(rst_x_1+line_r_length,rst_y_1-line_r_length,
				      rst_x_1-line_r_length,rst_y_1+line_r_length,LIGHT_RED);
				snd_sdead();
				xline(rst_x_2-line_r_length,rst_y_2-line_r_length,
				      rst_x_2+line_r_length,rst_y_2+line_r_length,LIGHT_RED);
				snd_sdead();
				xline(rst_x_3+line_r_length,rst_y_3-line_r_length,
				      rst_x_3-line_r_length,rst_y_3+line_r_length,LIGHT_RED);
				snd_sdead();
				xline(rst_x_4-line_r_length,rst_y_4-line_r_length,
				      rst_x_4+line_r_length,rst_y_4+line_r_length,LIGHT_RED);
				snd_sdead();

				if(line_r_total<30)
					line_r_total++;
				r_loop++;
			}

		}


		tc_start();	/* restart man for next time */
		erase_screen();	/* erase any trail on screen */
	}
}


create_man()	/* draw lines toward man, then draw man on screen */
{
	int	s_loop, r_loop, line_s_length, line_r_length;
	int	set_x_1, set_y_1, set_x_2, set_y_2, set_x_3, set_y_3, set_x_4, set_y_4;
	int	rst_x_1, rst_y_1, rst_x_2, rst_y_2, rst_x_3, rst_y_3, rst_x_4, rst_y_4;

	init_salive();	/* sound for alive */
	if(new_man) {	/* only restart if a man is on screen */

		set_x_1=m_x_pos; set_x_2=m_x_pos; set_x_3=m_x_pos; set_x_4=m_x_pos; 
		set_y_1=m_y_pos; set_y_2=m_y_pos; set_y_3=m_y_pos; set_y_4=m_y_pos; 
		rst_x_1=m_x_pos; rst_x_2=m_x_pos; rst_x_3=m_x_pos; rst_x_4=m_x_pos; 
		rst_y_1=m_y_pos; rst_y_2=m_y_pos; rst_y_3=m_y_pos; rst_y_4=m_y_pos; 

		for(s_loop=0; s_loop<40; s_loop++) {
				set_x_1+=2; set_y_1+=2;	/* direction 7 */
				set_x_2+=2; set_y_2-=2;	/* direction 1 */
				set_x_3-=2; set_y_3-=2;	/* direction 3 */
				set_x_4-=2; set_y_4+=2;	/* direction 5 */
				rst_x_1+=2; rst_y_1+=2;	/* direction 7 */
				rst_x_2+=2; rst_y_2-=2;	/* direction 1 */
				rst_x_3-=2; rst_y_3-=2;	/* direction 3 */
				rst_x_4-=2; rst_y_4+=2;	/* direction 5 */

		}

		r_loop=40; s_loop=40;
		while(r_loop) {

			if(s_loop) {
				set_x_1-=2; set_y_1-=2;	/* direction 7 */
				set_x_2-=2; set_y_2+=2;	/* direction 1 */
				set_x_3+=2; set_y_3+=2;	/* direction 3 */
				set_x_4+=2; set_y_4-=2;	/* direction 5 */

				xpset(set_x_1,set_y_1,LIGHT_RED);
				xpset(set_x_1,m_y_pos,LIGHT_RED);
				xpset(set_x_2,set_y_2,LIGHT_RED);
				xpset(m_x_pos,set_y_2,LIGHT_RED);
				xpset(set_x_3,set_y_3,LIGHT_RED);
				xpset(set_x_3,m_y_pos,LIGHT_RED);
				xpset(m_x_pos,set_y_4,LIGHT_RED);
				xpset(set_x_4,set_y_4,LIGHT_RED);
				snd_salive();	/* update alive sound */
	
				s_loop--;

			}


                        if(s_loop<20) {
				rst_x_1-=2; rst_y_1-=2;	/* direction 7 */
				rst_x_2-=2; rst_y_2+=2;	/* direction 1 */
				rst_x_3+=2; rst_y_3+=2;	/* direction 3 */
				rst_x_4+=2; rst_y_4-=2;	/* direction 5 */


				xpset(rst_x_1,rst_y_1,LIGHT_RED);
				xpset(rst_x_1,m_y_pos,LIGHT_RED);
				xpset(rst_x_2,rst_y_2,LIGHT_RED);
				xpset(m_x_pos,rst_y_2,LIGHT_RED);
				xpset(rst_x_3,rst_y_3,LIGHT_RED);
				xpset(rst_x_3,m_y_pos,LIGHT_RED);
				xpset(m_x_pos,rst_y_4,LIGHT_RED);
				xpset(rst_x_4,rst_y_4,LIGHT_RED);
				snd_salive();	/* update alive sound */

				r_loop--;
			}
		}

	}
}



move_m_temp(direct)	/* get new values for temp variables acording to direction of travel */
int	direct;
{
	switch(direct) {
	case 0:	/* direction is to the right */
		m_x_temp++;
		break;
	case 1:	/* direction is up and to the right */
		m_x_temp++; m_y_temp--; 
		break;
	case 2:	/* direction is up */
		m_y_temp--;
		break;
	case 3:	/* direction is up and to the left */
		m_x_temp--; m_y_temp--; 
		break;
	case 4:	/* direction is to the left */
		m_x_temp--;
		break;
	case 5:	/* direction is down and to the left */
		m_x_temp--; m_y_temp++; 
		break;
	case 6:	/* direction is down */
		m_y_temp++;
		break;
	case 7:	/* direction is down and to the right */
		m_x_temp++; m_y_temp++; 
		break;
	default:
#ifdef DEBUG
		cprintf("error in movement\n\r");
#endif
		break;
	}	
}



dec_m_step_direction()	/* decrement the step direction value with wrap-around */
{
	m_dir_temp--;
	if(m_dir_temp<0)
		m_dir_temp=7;
}


inc_m_step_direction()	/* increment the step direction value with wrap-around */
{
	m_dir_temp++;
	if(m_dir_temp>7)
		m_dir_temp=0;
}


erase_screen()	/* erase trail of man */
{
	int	y, loop, colision;


	loop=0;
	while(loop<man_dot_count && man_dot_count>0) {
		colision=pset(new_dot[X_POS][loop], new_dot[Y_POS][loop], BLACK);
		if(!(colision & 0x8080))
			pset(new_dot[X_POS][loop], new_dot[Y_POS][loop], get_color(colision));
		loop++;
	}

}



claim_screen()	/* fill area bordered by mans trail & change trail from light to dark white */
{
	int	loop, colision;

	init_fill();	/* start fill sound */
	loop=0;
	while(loop<man_dot_count) {	/* change color of trail */
		pset(new_dot[X_POS][loop], new_dot[Y_POS][loop], DARK_WHITE);
		loop++;
	}

	bcount=0;
	draw_styx();  /* redraw styx so they apear the same after the fill */
	era_styx();	/* erase styx from memory buffer */
	fill(fill_color);	/* fill all black dots on the screen with new color */
	screen=FALSE;	/* don't show fill in progress */
	pset(x_start[0],y_start[0],fill_color);	/* set the first dot to fill - needed by polyfill() */
	sn2_up();	/* raise the tone of the fill sound */
	sn2_up();
	sn2_up();
	sn2_up();
	sn2_up();
	sn2_up();
	sn2_up();
	polyfill(x_start[0],y_start[0],BLACK,DARK_WHITE);	/* erase the area of the screen that the styx is in */
	sn2_down();	/* lower the tone of the fill sound */
	sn2_down();
	sn2_down();
	sn2_down();
	check_styx();	/* check if second styx is in shaded area */
	draw_styx();  	/* redraw styx */
	screen=TRUE;	/* show all screen draws */
	retscn();	/* get the memory buffer back on the screen */

	bcount+=man_dot_count;	/* update the amount filled variable */
	loop=1000-(bcount/(float)1324.4)*100;
	make_filled(loop);

	man_dot_count=0;	/* reset trail dot counter */
	
}


make_f_color(val)	/* change the fill color */
int	val;
{
	fill_color=val;

}



write_blank(pos)	/* used during score updating to blank out extra life men at top of screen */
int	pos;
{

#ifdef	DEBUG
	if(pos<1 || pos>5)
		cprintf(" error in write_blank \n\r");
#endif

	put(30+pos*7,2,man_c_image);

}




write_man(pos)	/* used during score updating to display extra life men at top of screen */
int	pos;
{

#ifdef	DEBUG
	if(pos<1 || pos>5)
		cprintf(" error in write_man \n\r");
#endif

	put(30+pos*7,2,man_image);

}



man_hide()
{
	xput(m_x_pos-2,m_y_pos-2,man_image);	/* erase man from memory buffer */

}


man_display()
{
	xput(m_x_pos-2,m_y_pos-2,man_image);	/* re-draw man in memory buffer */
}



