/*
***************************************************************************************************
***************************************************************************************************
**                                                                                               **
**                                                                                               **
**                                    A n t    A t t a c k                                       **
**                                                                                               **
**         T a s k    H    -    S o u n d    G e n e r a t i o n                                 **
**                                                                                               **
**                                                                                               **
**                                                                                               **
***************************************************************************************************
***************************************************************************************************
*/

#include	"styx.h"

#define TIMER_MODE	0x43
#define TIMER_PORT	0x42
#define INTERUPT_PORT	0x40
#define PORT_B		0x61
#define TIMER_ENABLE	0x01
#define SPEAKER_ENABLE	0x02
#define	ON		1
#define	OFF		0
#define	PULSE		1
#define	SQUARE		2


int	old_count, sound_freq, sound_on, sound2_on, sn2_stat, sn2_mode;
int	styx_period, styx_target, styx_linc, styx_hinc, styx_on;
int	stuck_period, stuck_stat;
int	sdead_period;
int	salive1, salive2;
int	smsg_count, smsg1, smsg2, smsg_cycle, smsg_rpt;
int	sfull_count;

int	t_period, p_period, p_width;

int	time_reg=1;
int	timetemp;	/* used to equalize time on different speed CPU's */
int	time_mul;	/* used to equilize sound pulse width on different speed CPU's */



find_speed ()
{

	int	flag;

	while (tick==0) { 	/* wait for tick to be zero */
		flag=flag;
	}
	while ( !(tick==0)) {	/* wait for tick to be not zero */
		flag=flag;
	}

	time_reg=0;
	timetemp=0;

	while (tick==timetemp) {	/* wait for tick to change */
		time_reg++;
	}

	time_mul=time_reg/3000;	/* adjust for pulse width music */
	if (time_mul<1)
		time_mul=1;

	time_reg-=3000;	/* adjust for PC speed */
	if (time_reg<1)
		time_reg=1;


}



tdelay ()
{

	/* equalize system clock speed */

	timetemp=0;
	while (timetemp<time_reg) {
		timetemp++;
	}

}






task_h()
{

	if(sound && !sound_on) {	/* if keyboard module flags sound on & it is not on in the program
					   then turn on in program */
		sound_on=TRUE;
	}

	if(!sound && sound_on) {	/* if keyboard module flags sound off & it is on in the program
					   then turn off in program */
		sound_on=FALSE;
		set_tone(40);	/* set tone to a high freq - turning speaker off causes a clic */
		sn2_off();	/* turn off all sound */
	}



	if((tick != old_count) && sound_on && !get_status()) {	/* update sound if it is a new tick and
									   the sound is on and not in demo mode */
		old_count=tick;	/* reset tick change value */

		chk_styx();	/* check for styx sound */
		chk_stuck();	/* check for stuck sound */
		sn2_new();	/* update sound */
	}


}



init_th()	/* initialize sound */
{

	old_count=tick;
	init_styx();
	init_stuck();

}

rst_sound()
{	/* turn off speaker port at end of game - used during developement */
	int	temp;

	temp=inp(PORT_B); 
	temp =temp & 0xfc & ~SPEAKER_ENABLE & ~TIMER_ENABLE;
	outp(PORT_B,temp);	/* turn off timer */

	outp(INTERUPT_PORT,0xff);
	outp(INTERUPT_PORT,0xff);

}


init_sound()
{	/* turn on speaker & start up the external 2 tone sound routine */
	int	temp;

	outp(TIMER_MODE,0xb6);	/* set timer mode */
	outp(TIMER_PORT,0x20);	/* initialize timer to a high freq. */
	outp(TIMER_PORT,0x0);

	temp=inp(PORT_B); 
	temp =temp & 0xfc | SPEAKER_ENABLE | TIMER_ENABLE;
	outp(PORT_B,temp);	/* turn on speaker */


	outp(TIMER_MODE,0x36);	/* speed up timer */
	outp(INTERUPT_PORT,0);
	outp(INTERUPT_PORT,0x80);

	sound_on=TRUE;	/* set sound on flag */
	sound2_on=FALSE;	/* Reset sound2 flag */
	sn2on=0;
	sn2_mode=1;	/* initialize to pulse mode */
	p_period=12000;
	p_width=1;
	t_period=40;	
	sn2_stat=ON;	/* needed to insure that sn2_off will turn off sound */
	sn2_off();	/* turn off all sound to begin */
	
	init_th();
	sn2_start();	/* initialize interupt sound */

}

/* ***************************************************************************
   	styx sounds
   ***************************************************************************
*/

init_styx()
{
	
	styx_target=2000;
	styx_period=2000;
	p_width=15;
	styx_linc=1;
	styx_hinc=5;
	styx_on=FALSE;

}


chk_styx()
{
	int	temp;

	if(styx_on) {

		sn2_mode=PULSE;
		if(styx_target<styx_period)
			styx_period-=5;
		if(styx_target>styx_period)
			styx_period+=5;


		t_period=10;
		p_period=(styx_period)*2;
		if(random(5)==1) {
			styx_linc=random(3)-1;
			styx_hinc=random(14)-5;
		}
		p_width+=styx_linc;
		if(p_width>20 || p_width<10)
			p_width+=styx_hinc;
		if(p_width>50) {
			styx_hinc=-styx_hinc;
			styx_linc=-1;
			p_width=50;
		}
		if(p_width<1) {
			styx_hinc=random(5)+2;
			styx_linc=1;
			p_width=0;
		}	

	}

}



snd_styx(a)
{
	styx_on=TRUE;
	styx_target=a*5+1500;

}



/* ***************************************************************************
   	stuck sounds
   ***************************************************************************
*/

init_stuck()
{
	stuck_stat=FALSE;

}


chk_stuck()
{
	if(stuck_stat) {
		sn2_mode=PULSE;
		p_period=2000-stuck_period*5;
		t_period=30000-(stuck_period*20);
		p_width=stuck_period;
	}

}



snd_stuck(period)
{
	stuck_period=period;
	stuck_stat=TRUE;

}


/* ***************************************************************************
   	area filling sound
   ***************************************************************************
*/


init_fill()
{
	int	freq1, freq2;

	freq1=4000;	/* t_period value */
	freq2=2020;	/* p_period value */
	styx_on=FALSE;
	stuck_stat=FALSE;
	sn2_mode=SQUARE;
	switch(get_mult() ) {
	case 2:
		t_period=freq1;
		p_period=freq2;
		break;

	case 3:
		t_period=freq1*0.7937 ;
		p_period=freq2*0.7937;
		break;

	case 5:
		t_period=freq1*0.66742;
		p_period=freq2*0.66742;
		break;
	}

	sn2_new();

}


sn2_up()	/* raise boath tones one note */
{

	t_period=t_period*0.943874;
	p_period=p_period*0.943874;
	sn2_new();
	sleep(1);
}


sn2_down()	/* lowet boath tones one note */
{
	t_period=t_period*1.059463;
	p_period=p_period*1.059463;
	sn2_new();
	sleep(1);

}


/* ***************************************************************************
   	screen full & new high score sounds
   ***************************************************************************

	these sounds are made as the background memory buffer is being cleared 

*/

init_sfull()
{
	styx_on=FALSE;
	stuck_stat=FALSE;
	
	sn2_mode=SQUARE;
	sn2_off();
	sfull_count=0;

}



snd_sfull()
{

	switch(sfull_count) {
	case 0:
		p_period=4561;	/* tone 1 = C4 */
		t_period=3044/2;	/* tone 2 = G4 */
		break;

	case 1:
		t_period=3620/2;	/* tone 2 = E4 */
		break;

	case 2:
		t_period=3044/2;	/* tone 2 = G4 */
		break;

	case 3:
		t_period=3620/2;	/* tone 2 = E4 */
		break;

	case 4:
		t_period=3044/2;	/* tone 2 = G4 */
		break;

	case 5:
		t_period=3620/2;	/* tone 2 = E4 */
		break;

	case 6:
		t_period=3044/2;	/* tone 2 = G4 */
		break;

	case 7:
		t_period=3620/2;	/* tone 2 = E4 */
		break;



	case 8:
		p_period=4063;	/* tone 1 = D4 */
		t_period=2712/2;	/* tone 2 = A4 */
		break;

	case 9:
		t_period=3225/2;	/* tone 2 = F#4 */
		break;

	case 10:
		t_period=2712/2;	/* tone 2 = A4 */
		break;

	case 11:
		t_period=3225/2;	/* tone 2 = F#4 */
		break;

	case 12:
		t_period=2712/2;	/* tone 2 = A4 */
		break;

	case 13:
		t_period=3225/2;	/* tone 2 = F#4 */
		break;

	case 14:
		t_period=2712/2;	/* tone 2 = A4 */
		break;

	case 15:
		t_period=3225/2;	/* tone 2 = F#4 */
		break;


	case 16:
		p_period=3620;	/* tone 1 = E4 */
		t_period=2416/2;	/* tone 2 = B4 */
		break;

	case 17:
		t_period=2873/2;	/* tone 2 = G#4 */
		break;

	case 18:
		t_period=2416/2;	/* tone 2 = B4 */
		break;

	case 19:
		t_period=2873/2;	/* tone 2 = G#4 */
		break;

	case 20:
		t_period=2416/2;	/* tone 2 = B4 */
		break;

	case 21:
		t_period=2873/2;	/* tone 2 = G#4 */
		break;

	case 22:
		t_period=2416/2;	/* tone 2 = B4 */
		break;

	case 23:
		t_period=2873/2;	/* tone 2 = G#4 */
		break;


	}

	sn2_new();
	sfull_count++;

}



snd_slide()
{

	while(t_period<4561/2) {
		t_period+=t_period/100;
		sn2_new();
		sleep(3);
	}
}

/*	this routine not used 

misc_snd()
{
	int	loop;

	for(loop=0; loop<100; loop++) {
		p_period-=p_period/75;
		t_period-=t_period/75;
		sn2_new();
		sleep(2);
	}
	sn2_off();
}

*/


/* ***************************************************************************
   	styx dead sounds
   ***************************************************************************
*/

init_sdead()
{

	styx_on=FALSE;
	sn2_off();
	stuck_stat=FALSE;
	sdead_period=300;
	
}

snd_sdead()
{
	set_sound(sdead_period);
	sleep(1);
	set_sound(40);
	sdead_period+=sdead_period/100;

}




/* ***************************************************************************
   	styx alive sounds
   ***************************************************************************
*/

init_salive()
{

	styx_on=FALSE;
	sn2_off();
	stuck_stat=FALSE;
	salive1=2000;
	salive2=1000;	
}


snd_salive()
{

	sn2_mode=SQUARE;
	t_period=salive1;
	salive1-=salive1/50;
	p_period=salive2;
	salive2+=salive2/50;
	sn2_new();
	sleep(2);
}

/*	these routines not used 

init_smsg()
{
	styx_on=FALSE;
	sn2_off();
	stuck_stat=FALSE;
	smsg_cycle=0;
	smsg_count=0;
}



chk_smsg()
{

	int	temp;

	if((tick != old_count) && sound_on ) {	/* update sound if it is a new tick and
									   the sound is on and not in demo mode */
		old_count=tick;	/* reset tick change value */

		if(smsg_cycle)
			smsg_cycle--;
		else {
			smsg_cycle=3;
			t_period=notes[smsg_count];
			if(t_period!=40) {
				smsg_count++;
				set_sound(t_period);
			}			
		}


	}

}
*/


/* ***************************************************************************
   	interupt pulse sound routines
   ***************************************************************************
*/


sn2_new()	/* set new frequency for boath tone generators */
{
	int	temp;

	if(sound_on) {	/* only update if the sound is turned on */
		sn2_on();	/* insure that sound is on */
		set_tone(t_period); 	/* set first tone generator */
		if(p_period<500 && sn2_mode==SQUARE)	/* check maximum freq of interupts */
			p_period=500;
		if(p_period<1000 && sn2_mode==PULSE)
			p_period=1000;
		sound2=p_period;	/* set new tick counter value - presently not used */
		outp(INTERUPT_PORT,p_period & 0xff);
		outp(INTERUPT_PORT,p_period >> 8);	
		temp=p_width-10;
		if(temp<1)
			temp=1;
		if(temp>50)
			temp=50;
		per2=temp*time_mul;
	}

}


sn2_off()	/* turn off second sound source */
{
	int	temp;

	if(sn2_stat==ON) {	/* sound 2 is now on */
		sn2_stat=OFF;
		sn2on=0;
		set_tone(40);
		temp=inp(PORT_B); 
		temp =temp & 0xfc | SPEAKER_ENABLE | TIMER_ENABLE;
		outp(PORT_B,temp);	/* turn on speaker */
	}
}

sn2_on()	/* turn on second sound source */
{
	int	temp;

/* for pulse wave - sn2on = 1
   for square wave - sn2on = 2 */

	sn2on=sn2_mode;	/* turn sound on with desired mode */	

	if(sn2_stat==OFF && sound_on) {	/* sound 2 is now off */
		sn2_stat=ON;
		set_tone(40);
		temp=inp(PORT_B); 
		temp =temp & 0xfc | SPEAKER_ENABLE | TIMER_ENABLE;
		outp(PORT_B,temp);	/* turn on speaker */
	}

}

sn2_start()	/* start up interupt sound source if it is not already on */
{
	if(!sound2_on) {
		sn2_init();
		sound2_on=TRUE;
	}

}


sn2_stop()	/* stop interupt sound source if it is already on & stop sound source 1 */  
{
	int	temp;

	if(sound2_on) {
		sn2_rst();
		sound2_on=FALSE;
	}

	set_sound(40);	/* set to a high tone for no sound */

	temp=inp(PORT_B); 
	temp =temp & 0xfc | SPEAKER_ENABLE | TIMER_ENABLE;
	outp(PORT_B,temp);	/* turn on speaker */


	outp(TIMER_MODE,0x36);	/* speed up timer */
	outp(INTERUPT_PORT,0);
	outp(INTERUPT_PORT,0x80);

}



set_sound(period)	
{	/* if sound is on then set the timer to a value - used by high score sound routine ext. */

	if(sound_on) {
		outp(TIMER_PORT,period & 0xff);
		outp(TIMER_PORT,period >> 8);	
	}

}


set_tone(freq)
{	/* always sets the sound port - used within this task */
	outp(TIMER_PORT,freq & 0xff);
	outp(TIMER_PORT,freq >> 8);	

}
